//
// IntArray.cpp
//
// Implementation of IntArray
//
// CS213 Fall 2002
// Assignment #6

#include "StdAfx.h"

#include <iostream>
using namespace std;

#include "IntArray.h"

int &IntArray::operator[](int index)
{
    if ((index<0) || (index>=arraySize))
    {
      // Error condition, we don't quite know what
      // to do here.  We have to return something, because
      // the caller is expecting a reference.  We use a
      // temporary location 
	  cout << "An out of bounds condition has arisen" << endl;
      return temp;
    }
    
    return internal[index];
 
}

bool IntArray::resize(int newSize)
{
	if (newSize <= arraySize)
	{
		// Simply note that we've reduced the size of our integer 
		// array.  No need to play with memory.  
		arraySize = newSize;
		return true;
	}

	// OK, if we get here we need to allocate more memory.
	// Start by allocating a new block.
	int *newInternal = new int [newSize];

	// If the allocation did not succeed, return false and 
	// leave the original buffer (our current one pointed at
	// by the "internal" member variable) untouched
	if (!newInternal)
		return false;

	// OK, we were able to allocate new memory.
	// copy all of the contents of the original array into the new
	// one...
	for (int i=0; i<arraySize; i++)
		newInternal[i] = internal[i];

	// Now, delete the original buffer
	delete [] internal;

	// Finally, point the internal pointer at the new buffer
	internal = newInternal;

	// And last but not least, note the new size in arraySize
	arraySize = newSize;

	// All done!
	return true;
}