//
// IntArray.h
//
// Definition of the IntArray class
// 
// CS213 Fall 2002
// Assignment #6
//

class IntArray
{
public:
  // Here come the constructors
  IntArray()
  {
	  arraySize = 0;
	  internal = NULL;
  }
  
  IntArray(int initialSize)
  {
	internal = new int[initialSize];
	if (internal)
		arraySize = initialSize;
	else
		arraySize = 0;
  }

  // Here is the destructor
  ~IntArray()
  {
	if (internal)
		delete [] internal;
  }

  // And now the rest of the public member functions
  int getSize()
  {
	  return arraySize;
  }

  // These two are defined in IntArray.cpp
  int &operator[] (int index);
  bool resize(int newSize);  
  
private:
  int *internal;	// pointer to internal storage for our array
  int arraySize;	// number of entries allocated to internal
  int temp;			// A temporary location to return when operator[]
					// detects an out of bounds index
};
